/*
    WListViewEx.hpp

    NOTE: This file is a generated file.
          Do not modify it by hand!
*/

#ifndef WListViewEx_hpp_included
#define WListViewEx_hpp_included


// Declarations added here will be included at the top of the .HPP file
#pragma once

// =============================================================================
//
//  Copyright (C) 1997 Herbert Menke
//
//  This software is provided 'as-is', without any express or implied
//  warranty.  In no event will the author be held liable for any damages
//  arising from the use of this software.
//
//  Permission is granted to anyone to use this software for any purpose,
//  including commercial applications, and to alter it and redistribute it
//  freely.
//
//
//     If You find any bugs in this software, please send a mail to me:
//
//     Herbert Menke
//     Goetheallee 21
//     D 53225 Bonn
//     menke@blatzheim.com
//
// =============================================================================
//
// 
// This is a component, that enhanced the listview component.
// It adds the following features:
//   1) a click with the right mouse button adjust the column
//      width to fit the widest text in the column.
//   2) a click with the left mouse buttons, sorts the items
//      according to the specified column. If the column was
//      sorted, an arrow icon is displayed in the column heading.
//      ( same look and functionality as in Outlook express ).
//
//  Because the listview do not correctly redraw the header in the
//  ownerdraw mode while dragging the header, is was necessary to
//  attach the WColumnHeading component to the column header.

// There is also a bug in the Listview Component: Powersoft has forgotten
// that a header item could be ownerdraw. The WColumnHeadingItemType has
// only the WColumnHeadingBitmap and WColumnHeadingString members.
// On the other side the Event WOwnerDraw for the header is supported.

class WColumnHeadingEx;
#ifdef __OPTIMA_USE_COMPONENT_LIBRARIES__
#  pragma library("WListViewEx/WListViewEx.lib")
#endif // __OPTIMA_USE_COMPONENT_LIBRARIES__

#if !defined( __WListViewEx_declspec )
#define __WListViewEx_declspec
#endif

class __WListViewEx_declspec WListViewEx : public WListView
{
    public:
    public:
        // add your public instance data here
        WDeclareSubclass( WListViewEx, WListView);
    private:
        // add your private instance data here
    protected:
        // add your protected instance data here
        WBool              _sortColumnEnabled;  // flag to inidicate, columnsorting is enabled
        WBool              _sortAscending;      // the direction of the last sort
        WInt               _sortColumnIndex;    // the index of the last sorted column
        WInt               _sortFormat;         // the saved format of the last sorted column
        WColumnHeadingEx * _columnHeading;      // attached component for the column heading
    public:
        //
        // ColumnSortEnabled Property
        //

        // Enables or Disables Columnsorting

        WBool GetColumnSortEnabled() const;
        WBool SetColumnSortEnabled( WBool newValue );
    public:
        //
        // SortColumn Method
        //

        // Sort Column specified with columnIndex
        // ColumnSort must be enabled

        WBool SortColumn( WInt columnIndex, WBool ascending = true );
    public:
        WListViewEx();
    public:
        ~WListViewEx();
    private:
        WBool LoadWindow( WWindow * parent, const WResourceID & id, WModuleHandle module=_ApplicationModule );
    private:
        WBool MakeWindow( WWindow * parent, WUInt id, const WChar *className, const WChar *title, const WRect & r,  WStyle wstyle, WStyle exStyle, void * data=NULL );
    private:
        void _initInternals();
    private:
        WBool WCMDEF Event_DrawItem( WObject * object, WDrawItemEventData * event );
    private:
        WBool _setColumnSortFormat( WInt columnIndex, WInt sortFormat, WInt * pOldSortFormat = NULL );
    private:
        WBool WCMDEF Event_ColumnClick( WObject * object, WListViewEventData * event );
    private:
        WBool _swapRows( WInt row1, WInt row2 );
    private:
        WBool _qSortColumn( WInt & itemSelected, WInt columnIndex, WBool sortAscending, WInt lowItemIndex = 0, WInt highItemIndex = -1 );
    private:
        WBool _sortColumn( WInt columnIndex, WBool ascending );
    private:
        WBool Event_HeaderRightButtonDown( WObject * source, WMouseEventData * event );
    protected:
        WInt _setColumnSortIcon( WInt columnIndex = -1, WBool ascending = true, WBool update = false);
};

#endif
